#include <stdio.h>

typedef struct foo {
	int bank_account;
	float balance;
} foo_t;

typedef struct bar {
	float bank_account;
	int balance;
} bar_t;

void say_hello()
{
	printf("hello!!!\n");
}

int main(int argc, char **argv)
{
	// define a function pointer that points to the say_hello() function
	void (*say_hello_ptr)() = say_hello;

	// call the function via the function pointer
	say_hello_ptr();

	// print the value of the function pointer, i.e., the address of the function say_hello
	printf("say_hello_ptr: %p\n", say_hello_ptr);

	// get a pointer to the function pointer    |
	//                                          v
	unsigned char *char_ptr = (unsigned char *)(&say_hello_ptr);

	// the function pointer is just an address / unsigned integer
	printf("%02x ", char_ptr[0]);
	printf("%02x ", char_ptr[1]);
	printf("%02x ", char_ptr[2]);
	printf("%02x ", char_ptr[3]);
	puts("");

	// interpret the function pointer as an unsigned integer
	unsigned int *int_ptr = (unsigned int *)char_ptr;

	printf("%08x\n", *int_ptr);

	// interpret the function pointer as a string (char *)
	// NOTE: non printable characters will not be visible on the terminal (especially the \0 byte)
	// use ./type_casting | xxd to see all the bytes
	char *str_ptr = (char *)int_ptr;

	printf("%s\n", str_ptr);

	// ---------------------------------------------------------------------------------------
	// in C you can cast everything to everything O_o
	
	foo_t f;
	f.bank_account = 1337;
	f.balance = 1.234567;

	printf("f.bank_account: %d\n", f.bank_account);
	printf("f.balance: %f\n", f.balance);
	
	// cast foo_t to bar_t
	bar_t *g = (bar_t *)(&f);

	printf("g.bank_account: %d\n", g->bank_account);
	printf("g.balance: %f\n", g->balance);

	return 0;
}
